<!--
 * @Descripttion:
 * @version:
 * @Author: kBank
 * @Date: 2022-10-24 15:45:01
-->
<template>
  <div class="page">
    <topBar v-if="topList.length > 0"
            :topList="topList"
            :moren="moren"></topBar>
    <div class="main">
      <div class="form_all">
        <el-form ref="select"
                 :model="select"
                 label-width="auto">
          <el-row :gutter="40">
            <!-- 一层 -->
            <el-col :span="4">
              <el-form-item :label="'所属分类'">
                <el-select clearable
                           :placeholder="'请选择'"
                           v-model="select.pkClassify">
                  <el-option v-for="item in classifyList"
                             :key="item.pkId"
                             :label="item.name"
                             :value="item.pkId"></el-option>
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="4">
              <el-form-item :label="'规格名称'">
                <el-input clearable
                          v-model="select.typeName"></el-input>
              </el-form-item>
            </el-col>

            <el-col :span="4">
              <el-button type="primary"
                         @click="getDataList"> {{ '搜索' }}</el-button>
              <el-button type="primary"
                         class="resetBtn"
                         @click="reset"> {{ '重置' }}</el-button>
            </el-col>
          </el-row>
        </el-form>
      </div>
      <div class="maintop">
        <div class="mainbtn">
          <el-button size="small"
          v-hasButtons="['ggpzAdd']"
                     @click="openDig"
                     class="addBtn">{{'添加'}}</el-button>
          <el-button size="small"
          @click="handleExport"
          v-hasButtons="['ggpzExport']"
                     class="exportBtn"> {{ '导出' }}</el-button>
        </div>
      </div>
      <div class="maintable">
        <el-table :data="tableData"
        v-loading="loading"
                  style="width: 100%"
                  height="100%"
                  :header-cell-style="{ background: '#EEEEEE' }"
                  :row-class-name="tableRowClassName"
                  @selection-change="handleSelectionChange">
          <el-table-column type="selection"
                           width="55"> </el-table-column>
          <el-table-column align="center"
                           prop="sort"
                           sortable
                           :label="'排序'">
          </el-table-column>
          <el-table-column align="center"
                           prop="classifyName"
                           :label="'所属分类'">
          </el-table-column>
          <el-table-column align="center"
                           prop="typeName"
                           :label="'规格名称'">
          </el-table-column>
          <el-table-column align="center"
                           prop="specsArr"
                           :label="'规格参数'">
                           <template slot-scope="scope">

         <el-popover
 placement="top"
 width="300"
 trigger="hover">
<div>{{ scope.row.specsArr }}</div>
 <div slot="reference"> {{ scope.row.specsArrStr }}</div>
</el-popover>
         </template>
          </el-table-column>
          <el-table-column align="center"
                           prop="time"
                           :label="'操作'"
                           fixed="right">
            <template slot-scope="scope">
              <el-button @click="toFixed(scope.row.pkId)"
                         type="text"
                         v-hasButtons="['ggpzExport']"
                         style="color:#F3A900"
                         size="small">
                {{ '修改' }}
              </el-button>
              <el-button @click="handleDelete(scope.row.pkId)"
                         type="text"
                         v-hasButtons="['ggpzDelete']"
                         size="small"
                         style="color: #C8161D">
                {{ '删除' }}
              </el-button>
            </template>
          </el-table-column>
        </el-table>
      </div>
    </div>
    <pagination v-show="total>0"
                :total="total"
                :page.sync="queryParams.pageNum"
                :limit.sync="queryParams.pageSize"
                @pagination="getDataList" />
    <el-dialog :title="'添加'"
               :close-on-click-modal="false"
               :visible.sync="dialogVisible"
               width="40%"
               center
               :before-close="handleClose">
      <el-form ref="form"
               :rules="rules"
               :model="form"
               label-width="80px">
        <el-row>
          <el-col :span="12">
            <el-form-item :label="'所属分类'"
                          prop="pkClassify">
              <el-select clearable
                         v-model="form.pkClassify">
                <el-option v-for="item in classifyList"
                           :key="item.pkId"
                           :label="item.name"
                           :value="item.pkId"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="'规格名称'"
                          prop="typeName">
              <el-input clearable
                        v-model="form.typeName"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="'规格参数'"
                          prop='specsList'>
              <el-tag :key="tag.value"
                      v-for="tag in form.specsList"
                      closable
                      :disable-transitions="false"
                      @close="tagClose(tag.value)">
                {{tag.value}}
              </el-tag>
              <el-input clearable
                        class="input-new-tag"
                        v-if="inputVisible"
                        v-model="inputValue"
                        ref="saveTagInput"
                        size="small"
                        @keyup.enter.native="handleInputConfirm"
                        @blur="handleInputConfirm">
              </el-input>
              <el-button v-else
                         class="button-new-tag"
                         size="small"
                         @click="showInput">{{'新增'}}</el-button>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item :label="'排序'"
                          prop="sort">
              <el-input clearable
                        oninput="value=value.replace(/[^\d]/g,'')"
                        v-model="form.sort"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <span slot="footer"
            class="dialog-footer">
        <el-button @click="handleClose">{{'取消'}}</el-button>
        <el-button type="primary"
                   @click="onSubmit('form')">{{'确认'}}</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import topBar from '@/components/topBar'
import * as api from '@/api/product.js'
import { specsTypeUpdate, specsTypeSave } from '@/api/product'
export default {
  name: 'Bzpz',
  components: {
    topBar,
  },
  filters: {
     isAgree(val) {
      if (!val) {
        return '允许';
      } else {
        return '禁止';
      }
    },
  },
  data() {
    return {
      creationTime: [],
      select: {},
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
      },
      addOrEdit: '',
      total: 0,
      dialogVisible: false,
      tableData: [],
      loading:false,
      moren: '/goodsManage/skuRelease/ggpz',
      topList: [
        {
          name: '产品分类',
          path: '/goodsManage/skuRelease/cpfl',
        },
        {
          name: '规格配置',
          path: '/goodsManage/skuRelease/ggpz',
        },
        {
          name: '单位配置',
          path: '/goodsManage/skuRelease/dwpz',
        },
      ],
      form: {
        name: '',
        specsList: [],
        sort: '',
      },
      rules: {
        typeName: [
          { required: true, message: '请输入规格名称', trigger: 'blur' },
        ],
        pkClassify: [
          { required: true, message: '请选择所属分类', trigger: 'change' },
        ],
        specsList: [
          { required: true, message: '请选择规格参数', trigger: 'blur' },
        ],
        sort: [{ required: true, message: '请输入排序', trigger: 'blur' }],
      },
      classifyList: [],
      inputVisible: false,
      inputValue: '',
    }
  },
  mounted() {
    // 获取列表
    this.getDataList()
    // 所属分类
    this.getClassifyAll()
  },
  methods: {
    reset() {
      this.select = {}
      this.getDataList()
    },
    tagClose(tag) {
      this.form.specsList.forEach((item, index) => {
        if (item.value == tag) {
          this.form.specsList.splice(index, 1)
        }
      })
    },

    showInput() {
      this.inputVisible = true
      this.$nextTick((_) => {
        this.$refs.saveTagInput.$refs.input.focus()
      })
    },

    handleInputConfirm() {
      console.log(
        '%c [ this.inputValue ]-281',
        'font-size:13px; background:#253ae5; color:#697eff;',
        this.inputValue
      )
      let inputValue = this.inputValue

      if (inputValue) {
        this.form.specsList.push({ value: inputValue })
      }
      this.inputVisible = false
      this.inputValue = ''
    },

    // 所属分类
    getClassifyAll() {
      api.classifyAll().then((res) => {
        this.classifyList = res.data
      })
    },
    changeTime(val) {
      this.select.startCreateDate = val[0]
      this.select.endCreateDate = val[1]
    },
    // 点击修改
    toFixed(id) {
      this.addOrEdit = false
      this.dialogVisible = true
      api.specsTypeDetail({ specsTypeId: id }).then((res) => {
        res.data.specsList.forEach((item) => {
          item.value = item.specsName
          item.specsId = item.pkId
        })
        this.form = res.data
      })
    },
    // 删除
    handleDelete(id) {
      this.$confirm('确认删除?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning',
      }).then(() => {
        api.specsTypeDel(id).then((res) => {
          this.getDataList()
        })
      })
    },
    handleExport() {
      this.$confirm( '是否确认导出所有数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning',
      }).then((_) => {
        this.download(
          '/sale/manage/specsType/export',
          Object.assign({}, this.queryParams, this.select),
          `${'规格配置'}${new Date().getTime()}.xlsx`
        )
      })
    },
    onSubmit(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          let url = ''
          if (this.addOrEdit == true) {
            url = specsTypeSave
          } else {
            url = specsTypeUpdate
          }
          url(this.form).then((res) => {
            if (res.code == 200) {
              this.$message({
                message: res.msg,
                type: 'success',
              })
              // this.dialogVisible = false
              // 充值数据
              // this.$refs[formName].resetFields()
              this.handleClose()
              // 获取列表
              this.getDataList()
            }
          })
        } else {
          return false
        }
      })
    },
    handleClose() {
      this.form = { name: '', specsList: [], sort: '' }
      this.inputValue = ''
      this.dialogVisible = false
      this.$refs['form'].clearValidate()
      this.$refs['form'].resetFields()
    },
    openDig() {
      this.dialogVisible = true
      this.addOrEdit = true
    },
    getDataList() {
      this.loading = true
      api
        .specsTypeList(Object.assign({}, this.queryParams, this.select))
        .then((res) => {
          // specsName
          res.rows.forEach((item) => {
            item.specsArr = []
            item.specsList.forEach((cld) => {
              item.specsArr.push(cld.specsName)
            })
            item.specsArr = item.specsArr.toString()
          })
          res.rows.forEach(item=>{
          if(item.specsArr.length>7){
            item.specsArrStr = item.specsArr.substring(0,8) + '...'
          }else{
            item.specsArrStr = item.specsArr
          }
        })
        this.loading = false
          this.tableData = res.rows
          this.total = res.total
        })
    },
    handleSelectionChange(val) {},
    tableRowClassName({ row, rowIndex }) {
      if (rowIndex % 2 == 1) {
        return 'warning-row'
      } else if (rowIndex % 2 == 0) {
        return 'success-row'
      }
      return ''
    },
  },
}
</script>
<style scoped lang="scss">
::v-deep .el-table .warning-row {
  background: #f9f9f9;
}

::v-deep .el-table .success-row {
  background: #ffffff;
}
::v-deep .el-table thead {
  color: #000000;
}
::v-deep .el-select {
  width: 100%;
}
.uploadIcon ::v-deep .el-upload--picture-card {
  display: none !important; /* 上传按钮隐藏 */
}
.page {
  padding: 20px;
  background: #f9f9f9;
  font-size: 14px;
  .main {
    display: flex;
    flex-direction: column;
    border-radius: 8px;
    box-shadow: 0px 2px 20px 0px rgba(238, 238, 238, 0.5);
    .form_all {
      padding:0 20px;
      margin-bottom: 20px;
      background: #fff;
      border-radius: 8px;
    }
    .maintop {
      display: flex;
      padding: 0px 0 3px 0;
      justify-content: space-between;
      align-items: center;
      background: #fff;
      border-radius: 8px;
      .mainbtn {
        .thebtn1 {
          background: #3181e5;
          color: #ffffff;
        }
        .thebtn2 {
          background: #ffad41;
          color: #ffffff;
        }
      }
      .maintitle {
        font-size: 10px;
        font-family: MicrosoftYaHei;
        color: #999999;
      }
    }
    .maintable {
      flex: 1;
      overflow-y: auto;
    }
  }
  .tem {
    display: flex;
    align-items: center;
    justify-content: center;
    img {
      width: 28px;
      height: 20px;
      margin-right: 3px;
    }
  }
  .isRed {
    color: #ed1d25;
  }
  .isGreen {
    color: #1ab62b;
  }
  .bgImg {
    width: 48px;
    height: 48px;
  }
}
.openClose {
  text-align: right;
  margin-right: 10px;
  color: #3181e5;
}
</style>
